#!/usr/bin/env python
#Copyright (C) 2007 - JamesWP
#Copyright (C) 2007 - Daniel Bessler <danielb@kiba-dock.og>

##### sudo aptitude install python-feedparser 
import feedparser
from time import sleep
from commands import getoutput
from os import path
from sys import exit

import dbus
from dbus.mainloop.glib import DBusGMainLoop
import gobject

PLUGIN_NAME = "kiba-feeder"

#Check every 5 minutes for new mails
CHECK_INTERVALL = 300000

if getoutput("kiba-settings --get-bool feeder_enable") != "TRUE":
	exit()

WEB_BROWSER = getoutput("kiba-settings --get-char feeder_browser")
if WEB_BROWSER == "Unable to find Option 'weather_browser' in the Settings File":
	WEB_BROWSER = 'firefox'


#URLs you want to feed
FEED_URLS = ( \
	'http://www.neowin.net/fb.php?page=gamers', \
	'http://www.neowin.net/fb.php?page=main', \
	'http://www.neowin.net/fb.php?page=software', \
	'')

#Set this if you want to use a custom Theme THEME_DIRECTORY
THEME_DIRECTORY = ""
if THEME_DIRECTORY == "":
	if path.isdir('/home/mandrake/rpm/BUILD/kiba-dbus-plugins/themes/' + PLUGIN_NAME) == 1:
		THEME_DIRECTORY = '/home/mandrake/rpm/BUILD/kiba-dbus-plugins/themes/' + PLUGIN_NAME
	elif path.isdir('/usr/share/kiba-dock/icons/' + PLUGIN_NAME) == 1:
		THEME_DIRECTORY = '/usr/share/kiba-dock/icons/' + PLUGIN_NAME
	else:
		print "Kiba-Feeder: No theme found, exiting"
		exit()
THEME=THEME_DIRECTORY

STATUS_DIR='/tmp'

class KibaFeeder(object):
	icon = THEME + '/old.png'
	description = ""
	TimeCalc = 0	
	icon_added=0
	
	def __init__ (self):
		#start timeout, 1000 means every second
		source_id=gobject.timeout_add(CHECK_INTERVALL, self.timeout_func)
		
		#get the bus proxy
		self.bus = dbus.SessionBus()
		
		#Setup Signal Handlers (we need to avoid some uggly segfaults when kiba closes/reopenes)
		self.bus.add_signal_receiver(self.open_handler, dbus_interface = "org.kiba.dock.Kiba", signal_name = "Initialled")
		self.bus.add_signal_receiver(self.close_handler, dbus_interface = "org.kiba.dock.Kiba", signal_name = "Closed")
		self.bus.add_signal_receiver(self.context_menu_handler, dbus_interface = "org.kiba.dock.Kiba", signal_name = "IconMenu")
		self.bus.add_signal_receiver(self.button_release_handler, dbus_interface = "org.kiba.dock.Kiba", signal_name = "IconReleased")
		
		self.check_feeds()
		
		#check if kiba is running on startup
		if getoutput("pidof kiba-dock") != "":
			self.add_kiba_icon()
			self.set_icon_and_titel()
	
	def check_feeds (self):
		FeedNumber = 0
		self.TimeCalc = 0
		while True:
			if FeedNumber == (len(FEED_URLS)-1):
				break
			
			Feed = feedparser.parse(FEED_URLS[FeedNumber])
			
			FeedTitle = Feed['channel']['title']
			LatestItemTitle = Feed['items'][0]['title']
			LatestItemURL = Feed['items'][0]['link']
			LatestItemDate = Feed['items'][0]['date']
			
			Year = str(LatestItemDate.split(' ')[3])
			Month = str(12)
			Day = str(LatestItemDate.split(' ')[1])
			Time = str(LatestItemDate.split(' ')[4])
			Hour = str(Time.split(':')[0])
			Minute = str(Time.split(':')[1])
			Second = str(Time.split(':')[2])
			
			if int(Year + Month + Day + Hour + Minute + Second) > self.TimeCalc:
				self.TimeCalc = int(Year + Month + Day + Hour + Minute + Second)
				
				self.description = ('%s : %s' % (FeedTitle,LatestItemTitle))
				self.URL = LatestItemURL
				
			FeedNumber = (FeedNumber + 1)
			
		self.status = open(STATUS_DIR + '/Status.txt','r')
		self.status = str(self.status.readlines(1))
		if self.status != "[]":
			self.status = self.status.split("['")[1]
			self.status = self.status.split("']")[0]
		
		file(STATUS_DIR + '/Status.txt','w').write(str(self.TimeCalc))
		
	def set_icon_and_titel(self):
		if self.status == str(self.TimeCalc):
			self.icon = THEME + '/old.png'
		else:
			self.icon = THEME + '/new.png'
		
		self.kiba.SetIcon(PLUGIN_NAME, self.icon)
		self.kiba.SetTitel(PLUGIN_NAME, self.description)
	
	def add_kiba_icon(self):
		#Initiall Kiba-DBus stuff
		self.obj = self.bus.get_object("org.kiba.dock.Kiba", "/org/kiba/dock/Kiba")
		self.kiba = dbus.Interface(self.obj, "org.kiba.dock.Kiba")
		
		#Add Icon to Kiba
		self.kiba.AddObject(PLUGIN_NAME, "NULL", self.icon)
		
		self.icon_added=1
		
	def context_menu_handler(self, id):
		if id != PLUGIN_NAME:
			return
	
	def button_release_handler(self, id):
		if id != PLUGIN_NAME:
			return
		
		self.kiba.LaunchCommand('%s %s' % (WEB_BROWSER,self.URL))
		
	def close_handler(self, sender=None):
		self.icon_added=0
	
	def open_handler(self, sender=None):
		self.add_kiba_icon()
	
	def timeout_func(self):
		if self.icon_added == 0:
			return 1
		
		self.check_feeds()
		self.set_icon_and_titel()
		
		return 1

#We need to use the Mainloop to catch the DBus Signals
DBusGMainLoop(set_as_default=True)
loop=gobject.MainLoop()

#Load the Plugin
kiba_feeder=KibaFeeder()

#enter mainloop
loop.run()

if getoutput("pidof kiba-dock") != "":
	kiba_feeder.kiba.RemoveObject(PLUGIN_NAME)
